const WellKnownSids = {
  'AN': 'S-1-5-7',      // Anonymous Logon',
  'AO': 'S-1-5-32-548', // Account Operators',
  'AU': 'S-1-5-11',     // Authenticated Users',
  'BA': 'S-1-5-32-544', // Built-in Administrators',
  'BG': 'S-1-5-32-546', // Built in Guests',
  'BO': 'S-1-5-32-551', // Backup Operators',
  'BU': 'S-1-5-32-545', // Built-in Users',
  'CA': 'S-1-5-32-517', // Certificate Server Administrators',
  'CD': 'S-1-5-32-574', // Certificate DCOM Administrators',
  'CG': 'S-1-3-1',      // Creator Group',
  'CO': 'S-1-3-0',      // Creator Owner',
  'DA': 'S-1-32-512',   // Domain Administrators',
  'DC': 'S-1-32-515',   // Domain Computers',
  'DD': 'S-1-32-516',   // Domain Controllers',
  'DG': 'S-1-32-514',   // Domain Guests',
  'DU': 'S-1-32-513',   // Domain Users',
  'EA': 'S-1-32-519',   // Enterprise Administrators',
  'ED': 'S-1-5-9',      // Enterprise Domain Controllers',
  'HI': 'S-1-16-12288', // SDDL_ML_HIGH',
  'IU': 'S-1-5-4',      // Interactively logged-on user',
  'LA': 'S-1-5-21-500', // Local Administrator',
  'LG': 'S-1-5-21-501', // Local Guest',
  'LS': 'S-1-5-19',     // Local Service Account',
  'LW': 'S-1-16-4096',  // SDDL_ML_LOW',
  'ME': 'S-1-16-8192',  // SDDL_MLMEDIUM',
  'MU': 'S-1-5-32-558', // Performance Monitor users',
  'NO': 'S-1-5-32-556', // Network Configuration Operators',
  'NS': 'S-1-5-20',     // Network Service Account',
  'NU': 'S-1-5-2',      // Network Logon User',
  'PA': 'S-1-5-32-520', // Group Policy Administrators',
  'PO': 'S-1-5-32-550', // Printer Operators',
  'PS': 'S-1-5-10',     // Self',
  'PU': 'S-1-5-32-547', // Power Users',
  'RC': 'S-1-5-12',     // Restricted Code',
  'RD': 'S-1-5-32-555', // Terminal Server Users',
  'RE': 'S-1-5-32-552', // Replicator',
  'RO': 'S-1-5-32-498', // Enterprise Read-only domain controllers',
  'RS': 'S-1-5-32-553', // RAS Servers group',
  'RU': 'S-1-5-32-554', // Alias to allow previous Windows 2000',
  'SA': 'S-1-5-32-518', // Schema Administrators',
  'SI': 'S-1-16-16384', // System integrity level',
  'SO': 'S-1-5-32-549', // Server Operators',
  'SU': 'S-1-5-6',      // Service Logon User',
  'SY': 'S-1-5-18',     // Local System',
  'WD': 'S-1-1-0',      // Everyone'
};

const SddlAceTypes = {
  'A': 'ACCESS_ALLOWED_ACE_TYPE',
  'D': 'ACCESS_DENIED_ACE_TYPE',
  'OA': 'ACCESS_ALLOWED_OBJECT_ACE_TYPE',
  'OD': 'ACCESS_DENIED_OBJECT_ACE_TYPE',
  'AU': 'SYSTEM_AUDIT_ACE_TYPE',
  'AL': 'SYSTEM_ALARM_ACE_TYPE',
  'OU': 'SYSTEM_AUDIT_OBJECT_ACE_TYPE',
  'OL': 'SYSTEM_ALARM_OBJECT_ACE_TYPE',
  'ML': 'SYSTEM_MANDATORY_LABEL_ACE_TYPE',
  'XA': 'ACCESS_ALLOWED_CALLBACK_ACE_TYPE',
  'XD': 'ACCESS_DENIED_CALLBACK_ACE_TYPE',
  'RA': 'SYSTEM_RESOURCE_ATTRIBUTE_ACE_TYPE',
  'SP': 'SYSTEM_SCOPED_POLICY_ID_ACE_TYPE',
  'XU': 'SYSTEM_AUDIT_CALLBACK_ACE_TYPE',
  'ZA': 'ACCESS_ALLOWED_CALLBACK_ACE_TYPE'
};
/*
const SddlAceFlags = {
  'CI': 'CONTAINER_INHERIT_ACE',
  'OI': 'OBJECT_INHERIT_ACE',
  'NP': 'NO_PROPAGATE_INHERIT_ACE',
  'IO': 'INHERIT_ONLY_ACE',
  'ID': 'INHERITED_ACE',
  'SA': 'SUCCESSFUL_ACCESS_ACE_FLAG',
  'FA': 'FAILED_ACCESS_ACE_FLAG'
};
*/

const SddlAceRights = [
  // Generic access rights
  {right:'GA', mask: 0x10000000, name: 'GENERIC_ALL'},
  {right:'GX', mask: 0x20000000, name: 'GENERIC_EXECUTE'},
  {right:'GW', mask: 0x40000000, name: 'GENERIC_WRITE'},
  {right:'GR', mask: 0x80000000, name: 'GENERIC_READ'},
  // File access rights
  {right:'FA', mask: 0x1f01ff, name: 'FILE_ALL_ACCESS'},
  {right:'FR', mask: 0x120089, name: 'FILE_GENERIC_READ'},
  {right:'FW', mask: 0x120116, name: 'FILE_GENERIC_WRITE'},
  {right:'FX', mask: 0x1200a0, name: 'FILE_GENERIC_EXECUTE'},
  // Standard access rights
  {right:'SD', mask: 0x00010000, name: 'DELETE'},
  {right:'RC', mask: 0x00020000, name: 'READ_CONTROL'},
  {right:'WD', mask: 0x00040000, name: 'WRITE_DAC'},
  {right:'WO', mask: 0x00080000, name: 'WRITE_OWNER'},
  // Registry key access rights
  {right:'KA', mask: 0xf003f, name: 'KEY_ALL_ACCESS'},
  {right:'KR', mask: 0x20019, name: 'KEY_READ'},
  {right:'KW', mask: 0x20006, name: 'KEY_WRITE'},
  {right:'KX', mask: 0x20019, name: 'KEY_EXECUTE'},
  // Directory service object access rights
  {right:'RP', mask: 0x10, name: 'ADS_RIGHT_DS_READ_PROP'},
  {right:'WP', mask: 0x20, name: 'ADS_RIGHT_DS_WRITE_PROP'},
  {right:'CC', mask: 0x1, name: 'ADS_RIGHT_DS_CREATE_CHILD'},
  {right:'DC', mask: 0x2, name: 'ADS_RIGHT_DS_DELETE_CHILD'},
  {right:'LC', mask: 0x4, name: 'ADS_RIGHT_ACTRL_DS_LIST'},
  {right:'SW', mask: 0x8, name: 'ADS_RIGHT_DS_SELF'},
  {right:'LO', mask: 0x80, name: 'ADS_RIGHT_DS_LIST_OBJECT'},
  {right:'DT', mask: 0x40, name: 'ADS_RIGHT_DS_DELETE_TREE'},
  {right:'CR', mask: 0x100, name: 'ADS_RIGHT_DS_CONTROL_ACCESS'},
  // Mandatory label rights
  {right:'NR', mask: 0x2, name: 'SYSTEM_MANDATORY_LABEL_NO_READ_UP'},
  {right:'NW', mask: 0x1, name: 'SYSTEM_MANDATORY_LABEL_NO_WRITE_UP'},
  {right:'NX', mask: 0x4, name: 'SYSTEM_MANDATORY_LABEL_NO_EXECUTE'},
];

const ACE_LENGTH = 6;
const SddlInvalidType = { ok: 0x0000, owner: 0x0001, group: 0x0002, ace: 0x0004, no_system_ace: 0x0010 };
const AceRightsType = { Allow: 0, Deny: 1, None: 2 };

let _isSddlValid = SddlInvalidType.ok;

const getStrChecked = (value) => {
  return value ? value : '';
};

const IsRightsEqual = (ace, aceRights) => {
  return (ace && ace.rights && aceRights.every(i => ace.rights.includes(i)));
}

const GetAceRightsType = (vDeny, vAllow, aceRights) => {
  if(IsRightsEqual(vDeny, aceRights) )
      return AceRightsType.Deny;
  return IsRightsEqual(vAllow, aceRights) ? AceRightsType.Allow : AceRightsType.None;
}

const AceRightsAll = ['CC','DC','LC','SW','RP','WP','DT','LO','CR','SD','RC','WD','WO'];
const AceRightsUserAll  = ['DC','LC','SW','RP','WP','DT','LO','CR','SD','RC','WD','WO'];
const AceRightsRead = ['CC','LC','SW','LO','RC'];
const AceRightsUserRead = ['SW','LO','RC'];
const AceRightsModify = ['DC','RC'];
const AceRightsExecute = ['RP','WP','DT','CR','RC'];
const AceRightsUserReadModify    = ['DC','LC','SW','RP','WP','DT','LO','CR','RC'];
const AceRightsReadModifyExecute = ['CC','DC','LC','SW','RP','WP','DT','LO','CR','RC'];

const BinAceRightsAll = '0xf07fe';
const BinAceRightsUserReadModify = '0x207fe';
const BinAceRightsUserRead = '0x20288';

const ModelToUiPermissions = (model) => {
  if(!model)
    return { mode: 0, read: AceRightsType.Allow, modify: AceRightsType.Allow, execute: AceRightsType.Allow };

  // full deny control
  if(IsRightsEqual(model.D, model.isServiceRights ? AceRightsAll : AceRightsUserAll)) {
    return { mode: 1, read: AceRightsType.Deny, modify: AceRightsType.Deny, execute: AceRightsType.Deny }
  }
  if(!model.isServiceRights && IsRightsEqual(model.D, AceRightsUserReadModify)) {
    return { mode: 2, read: AceRightsType.Deny, modify: AceRightsType.Deny, execute: AceRightsType.Deny }
  }
  // full allow control
  if(IsRightsEqual(model.A, model.isServiceRights ? AceRightsAll : AceRightsUserAll)) {
    return { mode: 0, read: AceRightsType.Allow, modify: AceRightsType.Allow, execute: AceRightsType.Allow }
  }
  if(!model.isServiceRights && IsRightsEqual(model.A, AceRightsUserReadModify)) {
    return { mode: 2, read: AceRightsType.Allow, modify: AceRightsType.Allow, execute: AceRightsType.Allow }
  }
  // custom
  return {
    mode: 2,
    read: GetAceRightsType(model.D, model.A, model.isServiceRights ? AceRightsRead : AceRightsUserRead),
    modify: GetAceRightsType(model.D, model.A, AceRightsModify),
    execute: model.isServiceRights ? GetAceRightsType(model.D, model.A, AceRightsExecute) : AceRightsType.Allow
  }
}

const parseOwner = (value) => {
 if( WellKnownSids[value] === undefined )
    _isSddlValid |= SddlInvalidType.owner;
  return value;
}

const parseGroup = (value) => {
  if(WellKnownSids[value]===undefined)
    _isSddlValid |= SddlInvalidType.group;
  return value;
}

const parseAceType = (value) => {
  if(!value || SddlAceTypes[value]===undefined){
    _isSddlValid |= SddlInvalidType.ace;
    return '';
  }
  return value;
}

const parseAceRights = (value) => {
  let aceRights = [];
  if(!value || value===''){
    _isSddlValid |= SddlInvalidType.ace;
    return aceRights;
  }
  if('0x' === value.substr(0, 2)){
    if(value === BinAceRightsAll){
      return AceRightsUserAll;
    }
    if(value === BinAceRightsUserReadModify){
      return AceRightsUserReadModify;
    }
    if(value === BinAceRightsUserRead){
      return AceRightsUserRead;
    }

    let val = parseInt(value, 16);
    for (const item of SddlAceRights) {
      if ((val & item.mask) === item.mask) {
        aceRights.push(item.right);
        val -= item.mask;
      }
    }
  } else {
    for (let i = 0; i < value.length; i += 2) {
      aceRights.push(value.substr(i, 2));
    }
  }
  return aceRights;
}

const assembleAceRights = (rights, isBinary) => {
  if(isBinary){
    if((typeof rights === 'string') && ('0x' === rights.substr(0, 2)) ) {
      return rights;
    }

    // fix loosing some undescribed bytes
    if(AceRightsUserAll.every(i => rights.includes(i))) {
      return BinAceRightsAll;
    }
    if(AceRightsUserReadModify.every(i => rights.includes(i))) {
      return BinAceRightsUserReadModify;
    }
    if(AceRightsUserRead.every(i => rights.includes(i))) {
      return BinAceRightsUserRead;
    }

    let val = 0x0;
    for (const item of SddlAceRights) {
      if( rights.includes(item.right)) {
        val |= item.mask;
      }
    }
    const out = '0x' + val.toString(16).toLowerCase();
    return '0x' + val.toString(16).toLowerCase();
  }

  return rights ? rights.join('') : '';
}

const parseAceAccountSid = (value) => {
  if(!value || value===''){
    _isSddlValid |= SddlInvalidType.ace;
    return '';
  }
  return value;
}

const parseACE = (value) => {
  value = value.replace(/[\r\n\t]/g, '');
  if( value.charAt(0)!=='(' ) {
    _isSddlValid |= SddlInvalidType.ace;
  }

  value = value.replace('(', '');
  const rowAce = value.split(';');
  if(rowAce.length !== ACE_LENGTH) {
    _isSddlValid |= SddlInvalidType.ace;
  }
  const rowSid = parseAceAccountSid(rowAce[5]);
  const rowRights = rowAce[2];
  return {
    type: parseAceType(rowAce[0]),
    flags: getStrChecked(rowAce[1]),
    rights: parseAceRights(rowRights),
    bin_rights: ('0x' === rowRights.substr(0, 2)),
    object_guid: getStrChecked(rowAce[3]),
    inherit_object_guid: getStrChecked(rowAce[4]),
    rid: WellKnownSids[rowSid] ? rowSid : '',
    account_sid: WellKnownSids[rowSid] ? WellKnownSids[rowSid] : rowSid,
    resource_attribute: getStrChecked(rowAce[6])
  };
};

const assembleAce = (ace, key) =>{
  const aceT = ace[key];
  if(!aceT)
    return '';
  let strAce = '(' + key + ';';
  strAce += getStrChecked(aceT.flags) + ';';
  strAce += assembleAceRights(aceT.rights, aceT.bin_rights) + ';';
  strAce += getStrChecked(aceT.object_guid) + ';';
  strAce += getStrChecked(aceT.inherit_object_guid) + ';';
  strAce += (ace.rid !== '' ? ace.rid : ace.account_sid) + ')';
  return strAce;
};

const parseAcl = (value, isServiceRights) => {
  if( value.charAt(value.length-1)!==')' ) {
    _isSddlValid |= SddlInvalidType.ace;
  }

  const rowItems = value.split(')');
  const aceItems = [];
  for(const item of rowItems) {
    if(item==='')
      continue;
    const ace = parseACE(item);
    let found = aceItems.find(i=>{ return (i.account_sid === ace.account_sid); });
    if(found ){
      found[ace.type] = ace;
      found.Permissions = ModelToUiPermissions(found);
    } else {
      aceItems.push({
        account_sid : ace.account_sid,
        rid: ace.rid,
        isServiceRights: isServiceRights,
        [ace.type] : ace,
        Permissions: ModelToUiPermissions({[ace.type] : ace, isServiceRights: isServiceRights})
      });
    }
  }

  if(aceItems.length){
    const sys_ace = aceItems.filter(function (v) { return (v.A && v.A.rid==='SY'); });
    if(sys_ace.length===0 && isServiceRights)
      _isSddlValid |= SddlInvalidType.no_system_ace;
  } else {
    _isSddlValid |= SddlInvalidType.ace;
  }

  return aceItems;
};

const assembleAcl = (acl) => {
  let vAcls = [];
  for(const ace of acl){
    for (const name in SddlAceTypes) {
      if(ace[name]!==undefined)
        vAcls.push(assembleAce(ace, name));
    }
  }
  return vAcls.join('');
}

const updateComponents = (comp, key, value, isServiceRights) => {
  return {
    ...comp,
    owner: key === 'O' ? parseOwner(value) : comp.owner,
    group: key === 'G' ? parseGroup(value) : comp.group,
    dacl:  key === 'D' ? parseAcl(value, isServiceRights) : comp.dacl,
    sacl:  key === 'S' ? parseAcl(value, false) : comp.sacl,
  };
};

/*
* export interfaces
*/
const DefServerRightsSddl = () => {
  return 'O:SYG:SYD:(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)(A;;CCLCSWRPWPDTLOCRSDRC;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)';
};

const DefUserRightsSddl = () => {
  return 'O:SYG:BAD:(A;;0xf07fe;;;SY)(A;;0xf07fe;;;BA)(A;;0x20288;;;NS)';
};

const GetAllowingSystemAce = (isServiceRights) => {
    return {
        account_sid: 'S-1-5-18',
        rid: 'SY',
        isServiceRights: isServiceRights,
        A: {
            inherit_object_guid: '',
            flags: '',
            object_guid: '',
            resource_attribute: '',
            rid: 'SY',
            bin_rights: isServiceRights ? false : true,
            rights: isServiceRights ? AceRightsAll : BinAceRightsAll,
            type: 'A',
            account_sid: 'S-1-5-18'
        },
        Permissions: { mode: 0, read: 0, modify: 0, execute: 0}
    };
};

const OneDaclDefault = (isServiceRights) => {
  const rights = { flags: '', rights: [], object_guid: '', inherit_object_guid: '', resource_attribute: ''};
  return { isNew:true,
    account_sid: '',
    rid: '',
    isServiceRights: isServiceRights,
    A: rights, D: rights,
    Permissions: ModelToUiPermissions()
  };
};

const parseSDDL = (sddl, isServiceRights) => {
  _isSddlValid = SddlInvalidType.ok;
  let components = { owner: '', group: '', dacl: [], sacl: '', invalidType: SddlInvalidType.ok};
  // split all the components
  let  i = 0;
  let idx = 0;
  while (i !== -1) {
    i = sddl.indexOf(':', idx+1);
    if (i === -1) {
      break
    } else if (idx > 0) {
      components = updateComponents(components, sddl[idx-1], sddl.substring(idx+1, i-1), isServiceRights);
    }
    idx = i;
  }
  if (idx > 0) {
    components = updateComponents(components, sddl[idx-1], sddl.substring(idx+1), isServiceRights);
  }
  components.invalidType = _isSddlValid;
  return components;
};

const assembleSDDL = (comps) => {
  const dacl = assembleAcl(comps.dacl);
  const sacl = assembleAcl(comps.sacl);

  let sddl = 'O:' + comps.owner + 'G:' + comps.group + 'D:' + dacl;
  if(sacl){
    sddl += 'S:' + sacl;
  }
  return sddl;
}

const SidToRid = (sid) =>{
  for (const [key, value] of Object.entries(WellKnownSids)) {
    if(sid === value )
      return key;
  }
  return sid;
}

const GetPermissionsLoc = (rights, localization, isServiceRights) => {
  if(!rights)
    return '';

  if(typeof rights === 'string'){
    rights = parseAceRights(rights);
  }

  if(isServiceRights && AceRightsAll.every(i => rights.includes(i))) {
    return localization.get('Permissions.rows.all');
  }
  if(!isServiceRights && AceRightsUserAll.every(i => rights.includes(i))) {
    return localization.get('Permissions.rows.all');
  }

  let out = [];
  if(isServiceRights) {
    if( AceRightsRead.every(i => rights.includes(i))) {
      out.push(localization.get('Permissions.rows.read'));
    }
    if(AceRightsModify.every(i => rights.includes(i))) {
      out.push(localization.get('Permissions.rows.modify'));
    }
    if(AceRightsExecute.every(i => rights.includes(i))) {
      out.push(localization.get('Permissions.rows.execute'));
    }
  } else {
    if( AceRightsUserRead.every(i => rights.includes(i))) {
      out.push(localization.get('Permissions.rows.read'));
    }
    if(AceRightsModify.every(i => rights.includes(i))) {
      out.push(localization.get('Permissions.rows.modify'));
    }
  }
  return out.join(', ');
}

const UIPermissionsToModel = (model) => {
  const base = {account_sid: model.account_sid, rid: model.rid, Permissions: model.Permissions, isServiceRights: model.isServiceRights };
  // allow full control
  if(model.Permissions.mode === 0) {
    return { ...base, A: {
      rights: model.isServiceRights ? AceRightsAll : AceRightsUserAll,
      bin_rights: !model.isServiceRights } };
  }
  // deny full control
  if(model.Permissions.mode === 1) {
    return { ...base, D: {
      rights: model.isServiceRights ? AceRightsAll : AceRightsUserAll,
      bin_rights: !model.isServiceRights } };
  }
  // all custom deny service
  if(model.Permissions.read===AceRightsType.Deny && model.Permissions.modify===AceRightsType.Deny && model.Permissions.execute===AceRightsType.Deny){
    return { ...base, D: {
      rights: model.isServiceRights ? AceRightsReadModifyExecute : AceRightsUserReadModify,
      bin_rights: !model.isServiceRights } };
  }
  // all custorm deny user
  if(model.Permissions.read===AceRightsType.Deny && model.Permissions.modify===AceRightsType.Deny && !model.isServiceRights){
    return { ...base, D: {
            rights: AceRightsUserReadModify,
            bin_rights: !model.isServiceRights } };
  }
  // all custom allow service
  if(model.Permissions.read===AceRightsType.Allow && model.Permissions.modify===AceRightsType.Allow && model.Permissions.execute===AceRightsType.Allow){
    return { ...base, A: {
      rights: model.isServiceRights ? AceRightsReadModifyExecute : AceRightsUserReadModify,
      bin_rights: !model.isServiceRights } };
  }
  // all custom allow users
  if(model.Permissions.read===AceRightsType.Allow && model.Permissions.modify===AceRightsType.Allow && !model.isServiceRights){
    return { ...base, A: {
            rights: AceRightsUserReadModify,
            bin_rights: !model.isServiceRights } };
  }
  // mixed
  let arrDeny = [];
  let arrAllow = [];
  // read
  if(model.Permissions.read===AceRightsType.Deny) {
    arrDeny = AceRightsRead;
  } else if(model.Permissions.read===AceRightsType.Allow) {
    arrAllow = AceRightsRead;
  }
  // modify
  if(model.Permissions.modify===AceRightsType.Deny) {
    arrDeny = arrDeny.concat(AceRightsModify);
  } else if(model.Permissions.modify===AceRightsType.Allow) {
    arrAllow = arrAllow.concat(AceRightsModify);
  }
  // execute
  if(model.isServiceRights){
    if(model.Permissions.execute===AceRightsType.Deny) {
      arrDeny = arrDeny.concat(AceRightsExecute);
    } else if(model.Permissions.execute===AceRightsType.Allow) {
      arrAllow = arrAllow.concat(AceRightsExecute);
    }
  }

  arrDeny = arrDeny.filter((v, i, a) => a.indexOf(v) === i);
  arrAllow = arrAllow.filter((v, i, a) => a.indexOf(v) === i);

  return {
    ...base,
    A: { rights: arrAllow, bin_rights: !model.isServiceRights },
    D: { rights: arrDeny, bin_rights: !model.isServiceRights }
  };
}

module.exports = {
  SddlInvalidType,
  DefServerRightsSddl,
  DefUserRightsSddl,
  GetAllowingSystemAce,
  OneDaclDefault,
  parseSDDL,
  assembleSDDL,
  SidToRid,
  GetPermissionsLoc,
  UIPermissionsToModel
}