const base64js = require('base64-js');
const xml2js = require('xml2js');

const XMLtoJSON = ({ xml }) => {
    return new Promise((resolve, reject) => {
        xml2js.parseString(xml, function (err, result) {
            err ? reject(err) : resolve(result)
        });
    })
}

const ImportFromXmlToJson = async () => {
    try {
        const fileService = await runtime.get('services.file');
        const files = await fileService.upload({ accept: '.xml' });
        const b64 = await fileService.toBase64(files[0]);
        const bytes = base64js.toByteArray(b64);
        let text = new TextDecoder('utf-8').decode(bytes);
        text = text.replace("\ufeff", "");
        return await XMLtoJSON({xml:text});
    }
    catch (error) {
    }
    return {};
}

const ImportFromTxtToArray = async () => {
    try {
        const fileService = await runtime.get('services.file');
        const files = await fileService.upload({ accept:'.txt' });
        const b64 = await fileService.toBase64(files[0]);
        const bytes = base64js.toByteArray(b64);
        const text = new TextDecoder('utf-8').decode(bytes);
        return text.split('\n');
    }
    catch (error) {
    }

    return [];
}

const ParseTrustedInstallerStr = (s) =>{
    let out = {
        name: '',
        sha: ''
    };

    let tokens = s.split('*');
    if(tokens.length===2){
        out.sha = tokens[0].trim();
        out.name = tokens[1];
    }
    else {
        tokens = s.split(':');
        if(tokens.length===2){
            out.sha = tokens[1].trim();
            out.name = tokens[0].trim();
        }
    }

    return out;
}
const TextLinetoJson = (line) => {
    if(line === '')
        return '';
    let tokens = line.split('\t');
    tokens = tokens.filter((i) => { return (i.indexOf('{') === 0 ||  i.indexOf('"{') === 0); });
    if(tokens.length !==1 )
        return '';
    let token = tokens[0];
    if(token.charAt(0) === '"') {
        token = token.slice(1, -1);
        token = token.replaceAll('""', '"');
    }
    return token;
}

module.exports = {
    ImportFromXmlToJson,
    ImportFromTxtToArray,
    ParseTrustedInstallerStr,
    TextLinetoJson
}