const lo = require('lodash');
const hlp = require('../../../helpers')
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js')

const defPolicySections = ['DeviceControlPolicy','PredefinedTasksPolicy']
const formValues = ['Mode', 'SetAuditModeOnStop', 'Rules']

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.DeviceControlStartOptions);
    }
    if(formType!=='Main')
        return {}

    let data = {
        Form_Control_DevCtrlComon: hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.DeviceControlPolicy,formValues),
    }
    data.Form_Control_DevCtrlComon.LocalTask = true;
    // update rules to v 1.2
    data.Form_Control_DevCtrlComon.Rules.KLPRSS_Val[0] = data.Form_Control_DevCtrlComon.Rules.KLPRSS_Val[0].map(rule => {
        const serMask = rule.SerialMask && rule.SerialMask.KLPRSS_Val!== '' ? rule.SerialMask.KLPRSS_Val : rule.SerialNumber.KLPRSS_Val;
        return {
           ...rule,
           UseMaskByVendor: rule.UseMaskByVendor ? rule.UseMaskByVendor : { KLPRSS_Val: false },
           UserOrGroupOfRule: rule.UserOrGroupOfRule ? rule.UserOrGroupOfRule : { KLPRSS_Val: 'S-1-1-0' },
           SerialMask: { KLPRSS_Val: serMask }
        };
    });
    return data;
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    else if(formType==='Main'){
        const Common = hlp.ItemToLocalSettings(changedData.Form_Control_DevCtrlComon);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(Common, formValues));
    }
}

function RbacToPolicyCache(activePolicyCache){
    activePolicyCache.DeviceControlPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.DeviceControlPolicy, formValues);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['DeviceControlStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
