const lo = require('lodash');
const hlp = require('../../../helpers');
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js');
const utilsFim = require('../../utils/fim.js');

const defPolicySections = ['FileIntegrityMonitor','PredefinedTasksPolicy'];
const formValues = ['CheckOfflineChanges','CheckUSNCompromise','MonitorArea', 'UseTrustedZoneSettings'];

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.FileIntegrityMonitorStartOptions);
    }

    if(formType!=='Main')
        return {};

    let cmnData = hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.FileIntegrityMonitor,formValues);
    // update to version [1,3]
    if(cmnData.UseTrustedZoneSettings.KLPRSS_Mnd === undefined) {
        cmnData.UseTrustedZoneSettings = cmnData.CheckUSNCompromise;
        cmnData.UseTrustedZoneSettings.KLPRSS_Val = [false,false];
    }
    const data = {
        Form_SysInspect_FimCommon: {
            LocalTask: true,
            ...utilsFim.toViewMonitorArea(cmnData)
        },
    }
    return data;
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    else if(formType==='Main') {
        TASK_ADDITIONAL_PARAMS.Settings = utilsFim.toLocalSettings(changedData.Form_SysInspect_FimCommon);
    }
}

function RbacToPolicyCache(activePolicyCache){
    activePolicyCache.FileIntegrityMonitor = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.FileIntegrityMonitor, formValues);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['FileIntegrityMonitorStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
