const hlpPlc = require('../../../common/client/plc_tools.js');
const hlpSch = require('./TaskScheduleHelper.js');
//const hlpTime = require('../../../helpers_time.js')
//const utilsCmn = require('../../utils/common.js');

const defPolicySections = [];
const minPollingInterval = 60000;

const toView = (TASK_ADDITIONAL_PARAMS, activePolicyCache, formType, GroupTask, LockTask, bIsHosted, hostId) => {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule);
    }

    if(formType==='Main') {
        const cfgs = TASK_ADDITIONAL_PARAMS.Settings.PLCCheckerConfigs.map(function(cfgChecker) {
            const cfg = cfgChecker.Base;
            const minutes = Math.floor(cfgChecker.PollingInterval/(60*1000));
            const seconds = Math.floor(cfgChecker.PollingInterval/1000 - minutes*60);
            return {
                Enabled: cfgChecker.Enabled,
                Firmwares: cfgChecker.Firmwares,
                PollingMinutes: minutes,
                PollingSeconds: seconds,
                ConnectionSettings: cfg.ConnectionSettings,
                ControllerType: cfg.ControllerType,
                Description: cfg.Description,
                IPAddress:cfg.ConnectionSettings.S7Connection.Base.IPAddress,
                PortNumber:cfg.ConnectionSettings.S7Connection.Base.PortNumber,
                RackNumber:cfg.ConnectionSettings.S7Connection.RackNumber,
                SlotNumber:cfg.ConnectionSettings.S7Connection.SlotNumber,
                ReadDBBlocks:cfg.ConnectionSettings.S7Connection.ReadDBBlocks,
                PasswordAvailable:cfg.ConnectionSettings.S7Connection.Base.Base.PasswordAvailable,
                OldPassword:cfg.ConnectionSettings.S7Connection.Base.Base.Password.value,
                ViewConnectionsArray: hlpPlc.DisplayedCheckConnectionArray(cfg),
                InternalNetworkId: cfg.InternalNetworkId.InternalNetworkId,
                NetId: cfg.NetworkId.NetId,
                EditOnly:true
            };
        });

        return { Form_Task_PlcCheck_Settings: {
            PLCCheckerConfigs: cfgs,
            HostId: hostId
        }};
    }
    return {};
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType, hostId) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule)
    }
    else if(formType=='Main') {
       const cfgs = changedData.Form_Task_PlcCheck_Settings.PLCCheckerConfigs.map(function(cfgChecker) {
            const pollingInterval = Math.floor(((cfgChecker.PollingMinutes * 60 + cfgChecker.PollingSeconds) * 1000));
            return {
                Base: {
                    ConnectionSettings: cfgChecker.ConnectionSettings,
                    ControllerType: cfgChecker.ControllerType,
                    Description: cfgChecker.Description,
                    InternalNetworkId: { InternalNetworkId: cfgChecker.InternalNetworkId, __VersionInfo: [1,0] },
                    NetworkId: { NetId: cfgChecker.NetId, __VersionInfo: [1,0] },
                    __VersionInfo: [1,1]
                },
                Enabled: cfgChecker.Enabled,
                Firmwares: cfgChecker.Firmwares,
                PollingInterval: (pollingInterval > minPollingInterval) ? pollingInterval : minPollingInterval,
                __VersionInfo: [1,0]
            };
        });

        TASK_ADDITIONAL_PARAMS.Settings.PLCCheckerConfigs = cfgs;
    }
}

/*
function RbacToPolicyCache(activePolicyCache){
    return activePolicyCache;
}
*/

module.exports = {
    defPolicySections,
    toView,
    toRaw,
//    RbacToPolicyCache
};
