const lo = require('lodash');
const hlp = require('../../../helpers');
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js');
const utilsRegMon = require('../../utils/regmon.js');

const defPolicySections = ['RegistryAccessMonitorPolicy','PredefinedTasksPolicy'];
const formValues = ['AuditAccessOnly', 'MonitorArea', 'UseTrustedZoneSettings'];

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.RegistryAccessMonitorStartOptions);
    }

    if(formType!=='Main')
        return {};
    const cmnData = hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings, activePolicyCache.RegistryAccessMonitorPolicy, formValues);
    const viewData = utilsRegMon.toViewMonitorArea(cmnData);
    return {
        Form_RegMonCommon: { LocalTask: true, ...viewData }
    };
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    else if(formType==='Main') {
        const cmnData = utilsRegMon.toLocalSettings(changedData.Form_RegMonCommon);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(cmnData, formValues));
    }
}

function RbacToPolicyCache(activePolicyCache){
    activePolicyCache.RegistryAccessMonitorPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.RegistryAccessMonitorPolicy, formValues);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['RegistryAccessMonitorStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
