const lo = require('lodash');
const hlp = require('../../../helpers');
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js');

const defPolicySections = ['WiFiControlPolicy','PredefinedTasksPolicy'];
const formValues = ['Mode', 'Use whitelist', 'Whitelist'];

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return {
            ... hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.WiFiControlStartOptions),
            LocalTask: true
        } ;
    }

    if(formType==='Main') {
        const tmpSetts = {
            Mode:TASK_ADDITIONAL_PARAMS.Settings.mode,
            Whitelist:TASK_ADDITIONAL_PARAMS.Settings.white_list,
            ['Use whitelist']: TASK_ADDITIONAL_PARAMS.Settings.use_white_list
        };

        let data =  {
            Form_Control_WiFiComon: {
                ... hlp.localSettingsToView(tmpSetts,activePolicyCache.WiFiControlPolicy,formValues),
                LocalTask: true
            }
        };
        data.Form_Control_WiFiComon.UseWhiteList = data.Form_Control_WiFiComon['Use whitelist'].KLPRSS_Val[0];
        return data;
    }
    return {};
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }

    if(formType==='Main') {
        let wlist =[];
        changedData.Form_Control_WiFiComon.Whitelist.KLPRSS_Val[0].forEach(function(item) {
            wlist.push(hlp.ItemToLocalSettings(item));
        });

        TASK_ADDITIONAL_PARAMS.Settings = {
            ...TASK_ADDITIONAL_PARAMS.Settings,
            mode: changedData.Form_Control_WiFiComon.Mode.KLPRSS_Val[0],
            use_white_list: changedData.Form_Control_WiFiComon.UseWhiteList,
            white_list: wlist,

        };
    }
}

function RbacToPolicyCache(activePolicyCache){
    activePolicyCache.WiFiControlPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.WiFiControlPolicy, formValues);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['WiFiControlStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
