const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['HostBlockingPolicy']
const formValues = ['AutoBlockPeriod']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.HostBlockingPolicy.Policy.KLPRSS_Val, formValues)
    // convert minutes to days and hours
    const minutesToBlock = data.AutoBlockPeriod.KLPRSS_Val[0]
    data.days = parseInt(minutesToBlock / (24 * 60));
    data.hours = parseInt((minutesToBlock - (data.days * 24 * 60)) / 60);
    data.minutes = parseInt(minutesToBlock - (data.days * 24 * 60) - (data.hours * 60));
    return data
}

function toRaw (changedData, policiesCache) {
	let minutesToBlock = parseInt(changedData.days * 24 * 60 + changedData.hours * 60 + changedData.minutes);
    changedData.AutoBlockPeriod.KLPRSS_Val[0] = ( minutesToBlock < 1 ) ? 1 : minutesToBlock

    Object.assign( policiesCache.HostBlockingPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
