const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['MountDevicePolicy']
const formValues = ['ScanUsbDrive']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.MountDevicePolicy.Policy.KLPRSS_Val, formValues)
    let sett = data.ScanUsbDrive.KLPRSS_Val[0]
    if( sett.UseSizeLimit.KLPRSS_Val && sett.SizeLimit.KLPRSS_Val === 0)
        sett.SizeLimit.KLPRSS_Val = 1024
    return data
}

function toRaw (changedData, policiesCache) {
    let sett = changedData.ScanUsbDrive.KLPRSS_Val[0]
    if( sett.UseSizeLimit.KLPRSS_Val && sett.SizeLimit.KLPRSS_Val === 0)
        sett.SizeLimit.KLPRSS_Val = 1024
    Object.assign( policiesCache.MountDevicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
