const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['BLPolicy'];
const formValues = ['UseAutoScalability',
    'ScalabilityProcessCount', 'ScalabilityProcessCountUsedByRtp', 'ScalabilityLowPriorityProcessCount'
];
const formScanValues = ['RestoreFiletimesAfterScan','UseCPURestrictionOnScan','CPURestrictionValue','TemporaryScanFolder'];

function toView (policiesCache) {
    let computedData = {
        Scalability: hlp.customToView(policiesCache.BLPolicy.Policy.KLPRSS_Val, formValues),
        Scan: hlp.customToView(policiesCache.BLPolicy.Policy.KLPRSS_Val, formScanValues),
        Tray: policiesCache.BLPolicy.Policy.KLPRSS_Val.AutoStartTrayIconApplication
    };
    return computedData;
}

function toRaw (changedData, policiesCache) {
    changedData.Scalability.ScalabilityProcessCount.KLPRSS_Val[0] = changedData.Scalability.ScalabilityProcessCountUsedByRtp.KLPRSS_Val[0];
    Object.assign( policiesCache.BLPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Scalability, formValues));
    Object.assign( policiesCache.BLPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Scan, formScanValues));
    policiesCache.BLPolicy.Policy.KLPRSS_Val.AutoStartTrayIconApplication = changedData.Tray;
}

module.exports = {
    sections,
    toView,
    toRaw
};
