const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpSddl = require('../../../../common/client/sddl.js');

const sections = ['ProductPermissionPolicy'];
const formValues = ['UserRights'];

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.ProductPermissionPolicy.Policy.KLPRSS_Val, formValues);
    data.sddl = Buffer.from(data.UserRights.KLPRSS_Val[0]).toString();
    data.components = hlpSddl.parseSDDL(data.sddl, false);
    return data;
}

function toRaw (changedData, policiesCache) {
    let bytes = Buffer.from(changedData.sddl, 'utf-8');
    changedData.UserRights.KLPRSS_Val[0].length = 0;
    for(byte of bytes.values()){
        changedData.UserRights.KLPRSS_Val[0].push(byte);
    }
    delete changedData.sddl;
    Object.assign(policiesCache.ProductPermissionPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues));
}

module.exports = {
    sections,
    toView,
    toRaw
};
