const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpSchedule = require('../Schedule/schedule.js');

const sections = ['DeviceControlPolicy', 'PredefinedTasksPolicy'];
const formValues = ['Mode', 'SetAuditModeOnStop', 'Rules'];

function toView (policiesCache) {
    let data = {
        Form_Control_DevCtrlComon: hlp.customToView(policiesCache.DeviceControlPolicy.Policy.KLPRSS_Val, formValues),
        Form_Policy_DcSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.DeviceControlStartOptions)
    };
    // update rules to v 1.2
    data.Form_Control_DevCtrlComon.Rules.KLPRSS_Val[0] = data.Form_Control_DevCtrlComon.Rules.KLPRSS_Val[0].map(rule => {
        const serMask = rule.SerialMask && rule.SerialMask.KLPRSS_Val!== '' ? rule.SerialMask.KLPRSS_Val : rule.SerialNumber.KLPRSS_Val;
        return {
           ...rule,
           UseMaskByVendor: rule.UseMaskByVendor ? rule.UseMaskByVendor : { KLPRSS_Mnd: false, KLPRSS_Val: false },
           UserOrGroupOfRule: rule.UserOrGroupOfRule ? rule.UserOrGroupOfRule : { KLPRSS_Mnd: false, KLPRSS_Val: 'S-1-1-0' },
           SerialMask: rule.SerialMask ? rule.SerialMask : { KLPRSS_Mnd: false, KLPRSS_Val: rule.SerialNumber.KLPRSS_Val }
       };
    });
    return data;
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.DeviceControlPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Control_DevCtrlComon, formValues));
    hlpSchedule.toRaw(changedData.Form_Policy_DcSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.DeviceControlStartOptions);
    policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.EnableDeviceGeneratorTasksScheduling.KLPRSS_Mnd = policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.DeviceControlStartOptions.KLPRSS_Mnd;
 //
}

module.exports = {
    sections,
    toView,
    toRaw
};
