const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpSchedule = require('../Schedule/schedule.js');

const sections = ['WiFiControlPolicy', 'PredefinedTasksPolicy'];
const formValues = ['Mode', 'Use whitelist', 'Whitelist'];

function toView (policiesCache) {
    let data = {
        Form_Control_WiFiComon: hlp.customToView(policiesCache.WiFiControlPolicy.Policy.KLPRSS_Val, formValues),
        Form_WiFiSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.WiFiControlStartOptions)
    };
    data.Form_Control_WiFiComon.UseWhiteList = data.Form_Control_WiFiComon['Use whitelist'].KLPRSS_Val[0];
    return data;
}

function toRaw (changedData, policiesCache) {
    changedData.Form_Control_WiFiComon['Use whitelist'].KLPRSS_Val[0] = changedData.Form_Control_WiFiComon.UseWhiteList;
    Object.assign( policiesCache.WiFiControlPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Control_WiFiComon, formValues));
    hlpSchedule.toRaw(changedData.Form_WiFiSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.WiFiControlStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
