const lo = require('lodash');
const utilsNasac = require('../../../utils/nasac.js')
const hlp    = require('../../../../helpers')
const hlpSch = require('../Schedule/schedule.js')

const sections = ['NetAppAntiCryptor','PredefinedTasksPolicy']
const formCommonValues = ['EnforcementMode','UseHeuristicLevel','HeuristicLevel']
const formAuthValues = ['cDOTIpAddress','VserverName','FpolicyName','FPolicyServerPort','cDOTNodesList','cDOTAccess','PriveledgedAccess']
const formExclValues = ['UseExcludes','ExcludeRules']

function toView (policiesCache) {
    let data = {
        Form_Nas_AntiCryptCommon: hlp.customToView(policiesCache.NetAppAntiCryptor.Policy.KLPRSS_Val, formCommonValues),
        Form_Nas_AntiCryptAuth: hlp.customToView(policiesCache.NetAppAntiCryptor.Policy.KLPRSS_Val, formAuthValues),
        Form_Nas_AntiCryptExcludes :hlp.customToView(policiesCache.NetAppAntiCryptor.Policy.KLPRSS_Val, formExclValues),
        Form_Policy_NasAnticryptSchedule: hlpSch.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.NetAppAntiCryptorStartOptions)
    }
    data.Form_Nas_AntiCryptAuth =  utilsNasac.toViewAuth(data.Form_Nas_AntiCryptAuth);
    data.Form_Nas_AntiCryptExcludes = utilsNasac.toViewExclusions(data.Form_Nas_AntiCryptExcludes);
    return data
}

async function toRawEx(kscApi,changedData, policiesCache) {
    // common
    Object.assign( policiesCache.NetAppAntiCryptor.Policy.KLPRSS_Val, lo.pick(changedData.Form_Nas_AntiCryptCommon, formCommonValues));
    // auth
    changedData.Form_Nas_AntiCryptAuth = await utilsNasac.toRawAuth(changedData.Form_Nas_AntiCryptAuth, kscApi);
    Object.assign( policiesCache.NetAppAntiCryptor.Policy.KLPRSS_Val, lo.pick(changedData.Form_Nas_AntiCryptAuth, formAuthValues))
    // excludes
    changedData.Form_Nas_AntiCryptExcludes = utilsNasac.toRowExclusions(changedData.Form_Nas_AntiCryptExcludes);
    Object.assign(policiesCache.NetAppAntiCryptor.Policy.KLPRSS_Val, lo.pick(changedData.Form_Nas_AntiCryptExcludes, formExclValues))
    // schedule
    hlpSch.toRaw(changedData.Form_Policy_NasAnticryptSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.NetAppAntiCryptorStartOptions);
}

module.exports = {
    sections,
    toView,
    toRawEx
};
