const lo = require('lodash');
const utilNetApp = require('../../../utils/netapp')
const hlp = require('../../../../helpers')
const hlpSch = require('../Schedule/schedule.js')

const sections = ['NetAppMonitorPolicy','PredefinedTasksPolicy']
const formCommonValues = ['UseHeuristicAnalyzer', 'HeuristicAnalyzerLevel','NetAppConnectAsInfo',
    'CheckFilerStatusPeriod', 'AttemptFilerReconnectThreshold','ClearFilerCacheWhenAvBasesUpdated',
    'UseKsn', 'UseTrustedZoneSettings','UseSandbox']
const formScopeValues = ['ScanScope', 'ExcludedFromScanScope'];

function toView (policiesCache) {
    let data = {
        Form_Nas_NetAppCommon: hlp.customToView(policiesCache.NetAppMonitorPolicy.Policy.KLPRSS_Val, formCommonValues),
        Form_Nas_NetAppScope: hlp.customToView(policiesCache.NetAppMonitorPolicy.Policy.KLPRSS_Val, formScopeValues),
        Form_Policy_NetAppSchedule: hlpSch.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.NetAppTaskStartOptions)
    }
    data.Form_Nas_NetAppCommon = utilNetApp.toViewNetAppPswrd(data.Form_Nas_NetAppCommon);
    data.Form_Nas_NetAppScope.Areas = utilNetApp.toViewNetAppScanScope(data.Form_Nas_NetAppScope);
    return data;
}

async function toRawEx(kscApi, changedData, policiesCache) {
    // common
    changedData.Form_Nas_NetAppCommon = await utilNetApp.toRawNetAppPswrd(changedData.Form_Nas_NetAppCommon, kscApi);
    Object.assign(policiesCache.NetAppMonitorPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Nas_NetAppCommon, formCommonValues))
    // scopes
    const scopes = utilNetApp.toRowNetAppScanScope(changedData.Form_Nas_NetAppScope);
    Object.assign( policiesCache.NetAppMonitorPolicy.Policy.KLPRSS_Val, lo.pick(scopes, formScopeValues));
    // schedule
    hlpSch.toRaw(changedData.Form_Policy_NetAppSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.NetAppTaskStartOptions);
}

module.exports = {
    sections,
    toView,
    toRawEx
};
