const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpKsn = require('../../../utils/ksn');

const sections = ['KsnServicePolicy'];

async function toViewEx(kscApi, policiesCache) {
    let data = hlp.customToView(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, ['ConfirmTermsAndConditions','UseKmpService','UseKpsn']);
    data.LocEula = await hlpKsn.getKmpEula(kscApi);
    return data;
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, ['UseKmpService']));
}

module.exports = {
    sections,
    toViewEx,
    toRaw
};
