const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpKsn = require('../../../utils/ksn');

const sections = ['KsnServicePolicy'];
const formValues = ['ConfirmTermsAndConditions','UseUdsForFiles','UseUdsForUrls','SendStatistics','UseKpsn','UseKmpService'];

async function toViewEx(kscApi, policiesCache) {
    let data = hlp.customToView(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, formValues);
    data.ConfirmKpsn = (data.ConfirmTermsAndConditions.KLPRSS_Val[0] && data.UseKpsn.KLPRSS_Val[0]);
    data.LocEula = await hlpKsn.getKpsnEula(kscApi);
    return data;
}

function toRaw (changedData, policiesCache) {
    changedData.ConfirmTermsAndConditions.KLPRSS_Val[0] = changedData.ConfirmKpsn;
    changedData.UseKpsn.KLPRSS_Val[0] = changedData.ConfirmKpsn;
    changedData.UseUdsForFiles.KLPRSS_Val[0] = changedData.ConfirmKpsn;
    changedData.UseUdsForUrls.KLPRSS_Val[0] = changedData.ConfirmKpsn;
    changedData.SendStatistics.KLPRSS_Val[0] = changedData.ConfirmKpsn;
    changedData.UseKmpService.KLPRSS_Val[0] = changedData.ConfirmKpsn;
    Object.assign( policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toViewEx,
    toRaw
};
