const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpKsn = require('../../../utils/ksn')

const sections = ['KsnServicePolicy'];
const formValues = ['ConfirmTermsAndConditions','UseUdsForFiles','UseUdsForUrls','SendStatistics','UseKpsn'];

async function toViewEx(kscApi, policiesCache) {
    let data = hlp.customToView(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, formValues);
    data.LocEula = await hlpKsn.getEula(kscApi);
    return data;
}

function toRaw (changedData, policiesCache) {
    changedData.UseKpsn.KLPRSS_Val[0] = false;
    Object.assign( policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues));
    policiesCache.KsnServicePolicy.Policy.KLPRSS_Val.UseKmpService = changedData.ConfirmTermsAndConditions;
}

module.exports = {
    sections,
    toViewEx,
    toRaw
};
