const lo = require('lodash');
const apiUtils = require('../../../../common/open_api');
const hlp = require('../../../../helpers');
const hlpKsn = require('../../../utils/ksn');

const sections = ['KsnServicePolicy'];
const formValues = ['ConfirmTermsAndConditions','UseUdsForFiles','UseUdsForUrls','SendStatistics','UseKpsn'];

async function toViewEx(kscApi, policiesCache) {
    let data = hlp.customToView(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, formValues);
    data.isKpsn = await apiUtils.IsSetKpsnMode(kscApi);
    data.LocEula = data.isKpsn ? await hlpKsn.getKpsnEula(kscApi) : await hlpKsn.getEula(kscApi);
    return data;
}

function toRaw (changedData, policiesCache) {
    if(changedData.ConfirmTermsAndConditions.KLPRSS_ValLck===true)
        return;

    changedData.UseKpsn.KLPRSS_Val[0] = changedData.isKpsn;
    formValues.forEach(name => {
        changedData[name].KLPRSS_Mnd = true;
    });
    Object.assign(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues));
    policiesCache.KsnServicePolicy.Policy.KLPRSS_Val.UseKmpService = changedData.ConfirmTermsAndConditions;
}

module.exports = {
    sections,
    toViewEx,
    toRaw
};
