const lo    = require('lodash');
const hlp   = require('../../../../helpers');
const hlpSchedule = require('../Schedule/schedule.js');
const utilsFim = require('../../../utils/fim.js');

const sections = ['FileIntegrityMonitor','PredefinedTasksPolicy'];
const formValues = ['CheckOfflineChanges','CheckUSNCompromise','MonitorArea', 'UseTrustedZoneSettings'];

function toView (policiesCache) {
    let cmnData = hlp.customToView(policiesCache.FileIntegrityMonitor.Policy.KLPRSS_Val, formValues);
    // update to version [1,3]
    if(cmnData.UseTrustedZoneSettings.KLPRSS_Mnd === undefined){
        cmnData.UseTrustedZoneSettings.KLPRSS_Mnd = cmnData.CheckUSNCompromise;
        cmnData.UseTrustedZoneSettings.KLPRSS_Val = [false,false];
    }

    return {
        Form_SysInspect_FimCommon: utilsFim.toViewMonitorArea(cmnData),
        Form_Policy_FimSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.FileIntegrityMonitorStartOptions)
    }
}

function toRaw (changedData, policiesCache) {
    const FimCommon = utilsFim.toRowMonitorArea(changedData.Form_SysInspect_FimCommon);
    Object.assign( policiesCache.FileIntegrityMonitor.Policy.KLPRSS_Val, lo.pick(FimCommon, formValues));
    policiesCache.FileIntegrityMonitor.Policy.KLPRSS_Val.__VersionInfo = {KLPRSS_Mnd: false,KLPRSS_Val: [1, 3]}

    // schedule
    hlpSchedule.toRaw(changedData.Form_Policy_FimSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.FileIntegrityMonitorStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
