const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpSchedule = require('../Schedule/schedule.js');
const utilsRegMon = require('../../../utils/regmon.js');
const scheduleDef = require('../../../../default/schedule.js');

const sections = ['RegistryAccessMonitorPolicy','PredefinedTasksPolicy'];
const formValues = ['AuditAccessOnly', 'MonitorArea', 'UseTrustedZoneSettings'];

function toView (policiesCache) {
    const cmnData = hlp.customToView(policiesCache.RegistryAccessMonitorPolicy.Policy.KLPRSS_Val, formValues);
    return {
        Form_RegMonCommon: utilsRegMon.toViewMonitorArea(cmnData),
        Form_RegMonSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.RegistryAccessMonitorStartOptions)
    };
}

function toRaw (changedData, policiesCache) {
    const cmnData = utilsRegMon.toRowMonitorArea(changedData.Form_RegMonCommon);
    Object.assign(policiesCache.RegistryAccessMonitorPolicy.Policy.KLPRSS_Val, lo.pick(cmnData, formValues));
    // schedule
    if(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.RegistryAccessMonitorStartOptions === undefined) {
        policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.RegistryAccessMonitorStartOptions = scheduleDef.defaultPolicySchedule();
        policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.__VersionInfo = { KLPRSS_Mnd: false,  KLPRSS_Val : [2, 14] }
    }
    hlpSchedule.toRaw(changedData.Form_RegMonSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.RegistryAccessMonitorStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
