const lo = require('lodash');
const utilsTz = require('../../../utils/tz.js');

const sections = ['TrustedZonePolicy'];

function toView (policiesCache) {
    const tzProfile = policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val;
    let data = {
        Form_TrustedZones_Exclusions : {
            ExclutionRules : utilsTz.toViewExcludes(tzProfile.ExclutionRules2),
            isProfile: true,
            isExclutionsEditable : tzProfile.ExclutionRules2.KLPRSS_ValLck ? false : true
        },
        Form_TrustedZones_Processes: {
            TrustAllBackupReadOperations: tzProfile.TrustAllBackupReadOperations,
            TrustedProcessesEnabled: tzProfile.TrustedProcesses2Enabled,
            TrustedProcesses: utilsTz.toViewTrustedProcesses(tzProfile.TrustedProcesses2),
            isProfile: true
        }
    };
    data.Form_TrustedZones_Processes.TrustedProcessesEnabled.KLPRSS_Val[0] = true;
    return data;
}

function toRaw (changedData, policiesCache) {
    // excludes
    const exclusionRules = utilsTz.toRowExcludes(changedData.Form_TrustedZones_Exclusions.ExclutionRules);
    Object.assign( policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val.ExclutionRules2, exclusionRules);
    // trusted processes
    const tzProcForm = changedData.Form_TrustedZones_Processes;
    const trustedProcesses = utilsTz.toRowTrustedProcesses(tzProcForm.TrustedProcesses);
    policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val.TrustedProcesses2 = trustedProcesses;
    Object.assign(policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val.TrustedProcesses2Enabled, tzProcForm.TrustedProcessesEnabled);
    policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val.TrustedProcesses2Enabled.KLPRSS_Val[0] = true;
    Object.assign(policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val.TrustAllBackupReadOperations, tzProcForm.TrustAllBackupReadOperations);
}

module.exports = {
    sections,
    toView,
    toRaw
};
