const lo = require('lodash');
const hlp = require('../../../../helpers');
const utilsPep = require('../../../utils/pep.js');

const sections = ['ApplicationControlPolicy'];
const formRulesValues = ['RuleCollectionProfile', 'RuleUsageStrategyProfile'];

function toView (policiesCache) {
    const data = hlp.customToView(policiesCache.ApplicationControlPolicy.Policy.KLPRSS_Val, formRulesValues);
    return {
        ...data,
        uiFields: utilsPep.toViewProfileRules(data)
    };
}

function toRaw (changedData, policiesCache) {
    changedData = utilsPep.toRowProfileRules(changedData);
    Object.assign(policiesCache.ApplicationControlPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formRulesValues));
}

module.exports = {
    sections,
    toView,
    toRaw
};
