const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['HostBlockingSettings'];
const formValues = ['AutoBlockPeriod'];

function toView (settCache, activePolicyCache, hostId) {
    const data = hlp.localSettingsToView(settCache.HostBlockingSettings,activePolicyCache.HostBlockingSettings,formValues);
    // convert minutes to days and hours
    const minutesToBlock = data.AutoBlockPeriod.KLPRSS_Val[0];
    const days = parseInt(minutesToBlock / (24 * 60));
    const hours = parseInt((minutesToBlock - (days * 24 * 60)) / 60);
    return {
        ...data,
        hostId: hostId,
        LocalSettings: true,
        days: days,
        hours: hours,
        minutes: parseInt(minutesToBlock - (days * 24 * 60) - (hours * 60))
    };
}

function toRaw (changedData, settCache) {
	const minutesToBlock = parseInt(changedData.days * 24 * 60 + changedData.hours * 60 + changedData.minutes);
    changedData.AutoBlockPeriod.KLPRSS_Val[0] = ( minutesToBlock < 1 ) ? 1 : minutesToBlock
    hlp.ItemToLocalSettings(changedData);
    Object.assign(settCache.HostBlockingSettings, lo.pick(changedData, formValues));
}

module.exports = {
    sections,
    toView,
    toRaw
};
