const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['BLSettings'];
const formValues = ['UseAutoScalability','ScalabilityProcessCount','ScalabilityProcessCountUsedByRtp', 'ScalabilityLowPriorityProcessCount'];
const formScanValues = ['RestoreFiletimesAfterScan','UseCPURestrictionOnScan','CPURestrictionValue','TemporaryScanFolder'];

function toView (settCache, activePolicyCache) {
    let data = {
        Scalability: hlp.localSettingsToView(settCache.BLSettings,activePolicyCache.BLSettings,formValues),
        Scan: hlp.localSettingsToView(settCache.BLSettings,activePolicyCache.BLSettings,formScanValues),
        Tray: hlp.GetMergedLocalSettingsKey(settCache.BLSettings,activePolicyCache.BLSettings,'AutoStartTrayIconApplication'),
        LocalSettings:true
    }
    return data;
}

function toRaw (changedData, settCache) {
    let scalability = hlp.ItemToLocalSettings(changedData.Scalability);
    scalability.ScalabilityProcessCount = scalability.ScalabilityProcessCountUsedByRtp;
    Object.assign(settCache.BLSettings, lo.pick(scalability, formValues));

    const scan = hlp.ItemToLocalSettings(changedData.Scan);
    Object.assign(settCache.BLSettings, lo.pick(scan, formScanValues));

    settCache.BLSettings.AutoStartTrayIconApplication = changedData.Tray.KLPRSS_Val[0];
}

module.exports = {
    sections,
    toView,
    toRaw
};
