const lo = require('lodash');
const hlp = require('../../../../helpers');
const hlpSddl = require('../../../../common/client/sddl.js');

const sections = ['ProductPermissionSettings'];
const formValues = ['ServiceRights'];

function toView (settCache, activePolicyCache) {
    let data = hlp.localSettingsToView(settCache.ProductPermissionSettings,activePolicyCache.ProductPermissionSettings,formValues);
    data.sddl = Buffer.from(data.ServiceRights.KLPRSS_Val[0]).toString();
    data.components = hlpSddl.parseSDDL(data.sddl, true);
    data.LocalSettings=true;
    return data;
}

function toRaw (changedData, settCache) {
    const bytes = Buffer.from(changedData.sddl, 'utf-8');
    settCache.ProductPermissionSettings.ServiceRights.length = 0;
    for(byte of bytes.values()){
        settCache.ProductPermissionSettings.ServiceRights.push(byte);
    }
}

module.exports = {
    sections,
    toView,
    toRaw
};
