const lo = require('lodash');
const hlp = require('../../../helpers');

const sections = ['BLSettings'];
const formValues = ['EnableTrace','TraceFolder','TraceFileMaxSize','TraceSeverityLevel','TraceSubsystems',
    'UseTraceRotation','MaxTraceFilesToRotate','CreateCrashDump','CrashDumpFolder'];

function toView (settCache, activePolicyCache) {
    return {
        ...hlp.localSettingsToView(settCache.BLSettings, activePolicyCache.BLSettings, formValues),
        LocalSettings: true
    };
}

function toRaw (changedData, settCache) {
    hlp.ItemToLocalSettings(changedData);
    changedData.TraceSubsystems = "*";
    Object.assign(settCache.BLSettings, lo.pick(changedData, formValues));
}

module.exports = {
    sections,
    toView,
    toRaw
};
