const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['IncidentsSettings'];
const formValues = ['IncidentOptions'];

function toView (settCache, activePolicyCache) {
    if(settCache.IncidentsSettings.IncidentOptions.length===0){
        return {
            IncidentOptions: activePolicyCache.IncidentsSettings.IncidentOptions,
            LocalSettings:true
        };
    }
    return {
        ... hlp.localSettingsToView(settCache.IncidentsSettings, activePolicyCache.IncidentsSettings, formValues),
        LocalSettings:true
    };
}

function toRaw (changedData, settCache) {
    changedData = hlp.ItemToLocalSettings(changedData);
    Object.assign(settCache.IncidentsSettings, lo.pick(changedData, formValues));
}

module.exports = {
    sections,
    toView,
    toRaw
};
