const hlp = require('../../../../helpers.js');
const enums = require('../../../../types');
const utilsRpt  = require('../../../utils/report.js');

const sections = ['ReportingSettings'];

function GetLocalSettingsCustomEvents(uiEvent) {
    let customEvents = [];
    if(uiEvent.useCustom===false)
        return customEvents;

    for(let event of uiEvent.events){
        let oneEvent = {
            EventType:event.eventId,
            WriteToReports:event.log,
            WriteToEventLog:event.wel,
            __VersionInfo: [1, 0]
        };
        customEvents.push(oneEvent);
    }
    return customEvents;
}

function toView (settCache, activePolicyCache) {
    let data = {
        currentComponent: enums.ReportingSectionEnum.FileMonitor,
        Components: utilsRpt.ComponentData,
        LockSetts: hlp.GetMergedLocalSettingsKey(settCache.ReportingSettings,activePolicyCache.ReportingSettings, 'FileMonitorEventsStoreSettings'),
        LocalSettings:true
    }
    delete data.LockSetts.KLPRSS_Val;

    for (let key in data.Components) {
        let customEvent = data.Components[key];
        const pcEvents = hlp.GetMergedLocalSettingsKey(settCache.ReportingSettings,activePolicyCache.ReportingSettings, customEvent.key).KLPRSS_Val[0];
        utilsRpt.UpdateUiCustomEvent(customEvent, pcEvents);
    }
    return data
}

function toRaw(changedData, settCache) {
    let repSettings = settCache.ReportingSettings;

    for (let key in changedData.Components) {
        let customEvent = changedData.Components[key];
        let settEvent = repSettings[customEvent.key];
        if(settEvent===undefined)
            continue;
        settEvent.UseCustomEvents = customEvent.useCustom;
        if(settEvent.UseCustomEvents){
            settEvent.CustomEvents = GetLocalSettingsCustomEvents(customEvent);
        } else {
            settEvent.EventSeverity = (typeof customEvent.severity === 'string') ? parseInt(customEvent.severity) : customEvent.severity;
            settEvent.CustomEvents.length = 0;
        }
    }
    Object.assign(settCache.ReportingSettings, repSettings);
}

module.exports = {
    sections,
    toView,
    toRaw
};
