const lo = require('lodash');
const hlpSch = require('./TaskScheduleHelper.js')
const utilsRuleGen = require('../../utils/rule_gen.js')

function toView (TASK_ADDITIONAL_PARAMS, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule)
    }
    else if(formType === 'Main'){
        let data = utilsRuleGen.toViewAutoRuleGen(TASK_ADDITIONAL_PARAMS.Settings);
        data.Form_AutoRuleGenerator_Advanced.GroupTask = true;
        data.GroupTask = true;
        return data;
    }
    else if(formType === 'Wizard_Rules'){
        let data = utilsRuleGen.toViewWzAutoRuleGenRules(TASK_ADDITIONAL_PARAMS.Settings);
        data.GroupTask = true;
        return data;
    }
    else if(formType === 'Wizard_Adv'){
        let data = utilsRuleGen.toViewWzAutoRuleGenAdv(TASK_ADDITIONAL_PARAMS.Settings);
        data.GroupTask = true;
        return data;
    }
    else if(formType === 'Wizard_Excludes'){
        let data = utilsRuleGen.toViewWzAutoRuleGenExcludes(TASK_ADDITIONAL_PARAMS.Settings);
        data.GroupTask = true;
        return data;
    }
    return {};
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule)
    }
    else if(formType==='Main') {
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings,utilsRuleGen.toRowAutoRuleGen(changedData, TASK_ADDITIONAL_PARAMS.Settings));
    }
    else if(formType === 'Wizard_Rules'){
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings,utilsRuleGen.toRowWzAutoRuleGenRules(changedData, TASK_ADDITIONAL_PARAMS.Settings));
    }
    else if(formType === 'Wizard_Adv'){
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings,utilsRuleGen.toRowWzAutoRuleGen(changedData, TASK_ADDITIONAL_PARAMS.Settings));
    }
    else if(formType === 'Wizard_Excludes'){
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings,utilsRuleGen.toRowWzAutoRuleGenExcluded(changedData, TASK_ADDITIONAL_PARAMS.Settings));
    }
}

module.exports = {
    toView,
    toRaw
};
