const enums = require('../../types');
const utils = require('../../utils');

const toViewMonitorArea = (data) => {
    for(let item of data.MonitorArea.KLPRSS_Val[0]){
        item.Form_Fim_MonitorAreaUsers = {
            Users: utils.toViewArray(item.WhiteListUsers.KLPRSS_Val,'User')
        }
        item.Form_Fim_MonitorAreaMarkers = {
            Type:  (item.Reason.KLPRSS_Val===enums.AllFimOperators) ? 1 : 0,
            Reason: item.Reason.KLPRSS_Val,
            CalcHashAfterModify: item.CalcHashAfterModify.KLPRSS_Val,
            HashType: item.HashType.KLPRSS_Val
        }

        item.Form_Fim_MonitorAreaExclusions = {
            UseExclution:item.UseExclution.KLPRSS_Val,
            uiPathMasks:utils.toViewArray(item.ExclutionPathMask.KLPRSS_Val,'Path')
        }
    }
    return data;
}

const toRowMonitorArea = (changedData) => {
    for(let item of changedData.MonitorArea.KLPRSS_Val[0]){
        item.WhiteListUsers.KLPRSS_Val = utils.toRawArray(item.Form_Fim_MonitorAreaUsers.Users,'User');
        item.Reason.KLPRSS_Val = item.Form_Fim_MonitorAreaMarkers.Type===1 ? enums.AllFimOperators : item.Form_Fim_MonitorAreaMarkers.Reason;
        item.CalcHashAfterModify.KLPRSS_Val = item.Form_Fim_MonitorAreaMarkers.CalcHashAfterModify;
        item.HashType.KLPRSS_Val = item.Form_Fim_MonitorAreaMarkers.HashType;
        item.UseExclution.KLPRSS_Val = item.Form_Fim_MonitorAreaExclusions.UseExclution;
        item.ExclutionPathMask.KLPRSS_Val = utils.toRawArray(item.Form_Fim_MonitorAreaExclusions.uiPathMasks,'Path');

        delete item.Form_Fim_MonitorAreaUsers;
        delete item.Form_Fim_MonitorAreaMarkers;
        delete item.Form_Fim_MonitorAreaExclusions;
    }
    return changedData;
}

const toLocalSettings = (changedData) => {
    const mAreas = changedData.MonitorArea.KLPRSS_Val[0].map(item => {
        return {
            BlockModification: item.BlockModification.KLPRSS_Val,
            CalcHashAfterModify: item.Form_Fim_MonitorAreaMarkers.CalcHashAfterModify,
            Enable: item.Enable.KLPRSS_Val,
            ExclutionPathMask: item.Form_Fim_MonitorAreaExclusions.uiPathMasks.map(e => {return e.Path;}),
            HashType: item.Form_Fim_MonitorAreaMarkers.HashType,
            PathMask: item.PathMask.KLPRSS_Val,
            Reason: item.Form_Fim_MonitorAreaMarkers.Type===1 ? enums.AllFimOperators : item.Form_Fim_MonitorAreaMarkers.Reason,
            UniqueID: item.UniqueID.KLPRSS_Val,
            UseExclution: item.Form_Fim_MonitorAreaExclusions.UseExclution,
            WhiteListUsers: item.Form_Fim_MonitorAreaUsers.Users.map(u => {return u.User;}),
            __VersionInfo: [1,3]
        };
    });

    return {
        CheckOfflineChanges: changedData.CheckOfflineChanges.KLPRSS_Val[0],
        CheckUSNCompromise: changedData.CheckUSNCompromise.KLPRSS_Val[0],
        MonitorArea: mAreas,
        UseTrustedZoneSettings: changedData.UseTrustedZoneSettings.KLPRSS_Val[0],
        __VersionInfo: [1,2]
    }
}

module.exports = {
    toViewMonitorArea,
    toRowMonitorArea,
    toLocalSettings
}