
const upgradeAppRulesPolicy = (appRulesPolicy) => {
    return appRulesPolicy.map(rule => {
        return {
            RuleAction: { KLPRSS_Mnd: false, KLPRSS_Val: 0},
            ...rule,
            __VersionInfo: { KLPRSS_Mnd: false, KLPRSS_Val: [1, 2] }
        };
    });
}

const upgradePortRulesPolicy = (portRulesPolicy) => {
    return portRulesPolicy.map(rule => {
        return {
            PortAction: { KLPRSS_Mnd: false, KLPRSS_Val: 0},
            ...rule,
            __VersionInfo: { KLPRSS_Mnd: false, KLPRSS_Val: [1, 2] }
        };
    });
}

const toSettingsAppRule = (rule) => {
    const remoteAddress = rule.RemoteAddresses.KLPRSS_Val.trim();
    return {
        ApplicationName: rule.ApplicationName.KLPRSS_Val,
        Enabled: rule.Enabled.KLPRSS_Val,
        ImageFileName: rule.ImageFileName.KLPRSS_Val,
        IpVersion: rule.IpVersion.KLPRSS_Val,
        Protocol: rule.Protocol.KLPRSS_Val,
        RemoteAddresses: remoteAddress !== '' ? remoteAddress: '*',
        RuleAction: rule.RuleAction.KLPRSS_Val,
        __VersionInfo: [1,2]
    };
}

const toSettingsPortRule = (rule) => {
    return {
        ApplicationName: rule.ApplicationName.KLPRSS_Val,
        BuiltIn: rule.BuiltIn.KLPRSS_Val,
        Enabled: rule.Enabled.KLPRSS_Val,
        FirstPortRangeValue: rule.FirstPortRangeValue.KLPRSS_Val,
        IpVersion: rule.IpVersion.KLPRSS_Val,
        Port: rule.Port.KLPRSS_Val,
        PortAction: rule.PortAction.KLPRSS_Val,
        Protocol: rule.Protocol.KLPRSS_Val,
        RemoteAddresses: rule.RemoteAddresses.KLPRSS_Val,
        SecondPortRangeValue: rule.SecondPortRangeValue.KLPRSS_Val,
        UsePortRange: rule.UsePortRange.KLPRSS_Val,
        __VersionInfo: [1,2]
    };
}

module.exports = {
    upgradeAppRulesPolicy,
    upgradePortRulesPolicy,
    toSettingsAppRule,
    toSettingsPortRule
}