const LicTypeEnum = {
    KeyFile: 1,
    KeyKsc: 2,
    CodeKsc: 3,
    Code: 4
}

const getLicType = (TaskParams) => {
    if(TaskParams.KAV_WSEE_USE_ACTIVATION_CODE!==undefined && TaskParams.KAV_WSEE_USE_ACTIVATION_CODE==='1')
        return LicTypeEnum.Code;
    if(TaskParams.KAV_WSEE_INSTALL_KEY_PATH!=='')
        return LicTypeEnum.KeyFile;
    return (TaskParams.Settings.LicenseData.value!=='') ? LicTypeEnum.KeyKsc : LicTypeEnum.CodeKsc;
}

function toView(TaskAdditionalParams) {
    const licTypeActual = getLicType(TaskAdditionalParams);
    return {
        LicType: licTypeActual,
        KeyPath: TaskAdditionalParams.KAV_WSEE_INSTALL_KEY_PATH,
        InstallAsAdditional: TaskAdditionalParams.Settings.InstallAsActive ? false : true,
        KeyDataNew: '',
        KeyAcCode: TaskAdditionalParams.Settings.LicenseActivationCode,
        KeySerial: (TaskAdditionalParams.KAV_WSEE_KEY_SERIAL!==undefined) ? TaskAdditionalParams.KAV_WSEE_KEY_SERIAL : '',
        HasKeyFileInfo: (TaskAdditionalParams.KAV_WSEE_INSTALL_KEY_PATH==='' || TaskAdditionalParams.Settings.LicenseData.value==='') ? false : true,
    }
}

function toRow(changedData, TaskAdditionalParams) {
    const licType = ( changedData.LicType!==undefined ) ? changedData.LicType : changedData.Form_AddKey.LicType;
    if(licType!==LicTypeEnum.KeyFile) {
        TaskAdditionalParams.KAV_WSEE_INSTALL_KEY_PATH = '';
    }
    TaskAdditionalParams.KAV_WSEE_KEY_SERIAL = ( changedData.KeySerial!==undefined ) ? changedData.KeySerial : changedData.Form_AddKey.KeySerial;
    TaskAdditionalParams.KAV_WSEE_USE_ACTIVATION_CODE = (licType===LicTypeEnum.Code) ? '1' : '0';

    const newKeyData = ( changedData.KeyDataNew!==undefined ) ? changedData.KeyDataNew : changedData.Form_AddKey.KeyDataNew;
    TaskAdditionalParams.Settings.LicenseData.value = (licType===LicTypeEnum.KeyKsc) ? newKeyData : '';

    const newKeyCode = ( changedData.KeyAcCode!==undefined ) ? changedData.KeyAcCode : changedData.Form_AddKey.KeyAcCode;
    TaskAdditionalParams.Settings.LicenseActivationCode = (licType===LicTypeEnum.Code || licType===LicTypeEnum.CodeKsc) ?  newKeyCode : '';

    const bAdditional = ( changedData.InstallAsAdditional!==undefined ) ? changedData.InstallAsAdditional : changedData.Form_AddKey.InstallAsAdditional;
    TaskAdditionalParams.Settings.InstallAsActive = !bAdditional;
    return TaskAdditionalParams;
}

module.exports = {
    toView,
    toRow
}