//const enums = require('../../types');
//const utils = require('../../utils');

function toViewMonitorArea(data) {
    data.Mode = data.AuditAccessOnly.KLPRSS_Val[0] ? 1 : 0;

    for(let item of data.MonitorArea.KLPRSS_Val[0]){
        item.Form_RegMon_OneArea_Actions = {
            checkCreateKey: item.CheckCreateKey.KLPRSS_Val,
            checkDeleteKey: item.CheckDeleteKey.KLPRSS_Val,
            checkRenameKey: item.CheckRenameKey.KLPRSS_Val,
            checkSecurityKey: item.CheckChangeSecurityKey.KLPRSS_Val,
            checkDeleteValues: item.CheckDeleteValues.KLPRSS_Val,
            checkSetValues: item.CheckRenameValues.KLPRSS_Val,
            checkCreateSubkey: item.CheckCreateSubkeys.KLPRSS_Val,
            checkDeleteSubkey: item.CheckDeleteSubkeys.KLPRSS_Val,
            checkRenameSubkey: item.CheckRenameSubkeys.KLPRSS_Val,
            checkSecuritySubkey: item.CheckChangeSecuritySubkeys.KLPRSS_Val,
        }
        item.Form_RegMon_OneArea_Values = {
            ValueRules: item.ValueRules.KLPRSS_Val
        }
        item.Form_RegMon_OneArea_Users = {
            Users: item.WhiteListOfUsers.KLPRSS_Val.map(i => { return {User: i} })
        }
    }
    return data;
}

function toRowMonitorArea(changedData) {
    changedData.AuditAccessOnly.KLPRSS_Val[0] = changedData.Mode == 1 ? true : false;

    for(let item of changedData.MonitorArea.KLPRSS_Val[0]) {
        //
        item.CheckCreateKey.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkCreateKey;
        item.CheckDeleteKey.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkDeleteKey;
        item.CheckRenameKey.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkRenameKey;
        item.CheckChangeSecurityKey.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkSecurityKey;
        item.CheckDeleteValues.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkDeleteValues;
        item.CheckRenameValues.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkSetValues;
        item.CheckCreateSubkeys.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkCreateSubkey;
        item.CheckDeleteSubkeys.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkDeleteSubkey;
        item.CheckRenameSubkeys.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkRenameSubkey;
        item.CheckChangeSecuritySubkeys.KLPRSS_Val = item.Form_RegMon_OneArea_Actions.checkSecuritySubkey;
        // users
        item.WhiteListOfUsers.KLPRSS_Val = item.Form_RegMon_OneArea_Users.Users.map(u => {return u.User;});
        //item.WhiteListOfUsers.KLPRSS_Val = utils.toRawArray(item.Form_RegMon_OneArea_Users.Users,'User');
        // values
        item.ValueRules.KLPRSS_Val = item.Form_RegMon_OneArea_Values.ValueRules;

        delete item.Form_RegMon_OneArea_Actions;
        delete item.Form_RegMon_OneArea_Values;
        delete item.Form_RegMon_OneArea_Users;
    }
    return changedData;
}

function toLocalSettings(changedData) {
    const mAreas = changedData.MonitorArea.KLPRSS_Val[0].map(item => {
        return {
            CheckChangeSecurityKey: item.Form_RegMon_OneArea_Actions.checkSecurityKey,
            CheckChangeSecuritySubkeys: item.Form_RegMon_OneArea_Actions.checkSecuritySubkey,
            CheckCreateKey: item.Form_RegMon_OneArea_Actions.checkCreateKey,
            CheckCreateSubkeys: item.Form_RegMon_OneArea_Actions.checkCreateSubkey,
            CheckDeleteKey: item.Form_RegMon_OneArea_Actions.checkDeleteKey,
            CheckDeleteSubkeys: item.Form_RegMon_OneArea_Actions.checkDeleteSubkey,
            CheckDeleteValues: item.Form_RegMon_OneArea_Actions.checkDeleteValues,
            CheckRenameKey: item.Form_RegMon_OneArea_Actions.checkRenameKey,
            CheckRenameSubkeys: item.Form_RegMon_OneArea_Actions.checkRenameSubkey,
            CheckRenameValues: item.Form_RegMon_OneArea_Actions.checkSetValues,
            Enable: item.Enable.KLPRSS_Val,
            KeyMask: item.KeyMask.KLPRSS_Val,
            ValueRules: item.Form_RegMon_OneArea_Values.ValueRules.map(v => {
                return {
                    CheckDeleteValue: v.CheckDeleteValue.KLPRSS_Val,
                    CheckSetValue: v.CheckSetValue.KLPRSS_Val,
                    Enable: v.Enable.KLPRSS_Val,
                    ValueMask: v.ValueMask.KLPRSS_Val,
                    __VersionInfo: [1,0]
                };
            }),
            WhiteListOfUsers: item.Form_RegMon_OneArea_Users.Users.map(u => {return u.User;}),
            __VersionInfo: [1,1]
        };
    });

    return {
        AuditAccessOnly: changedData.Mode == 1 ? true : false,
        MonitorArea: mAreas,
        UseTrustedZoneSettings: changedData.UseTrustedZoneSettings.KLPRSS_Val[0],
        __VersionInfo: [1,1]
    }
}

module.exports = {
    toViewMonitorArea,
    toRowMonitorArea,
    toLocalSettings
}