const enums = require('../../types');
const utils = require('../../utils');

const toViewAutoRuleGen = (sett) => {
    return {
        Form_AutoRuleGenerator_Rules : {
            RuleNamePrefix: sett.RuleNamePrefix,
            RuleForRunningApplication: sett.RuleForRunningApplication,
            ScanAreas: sett.ScanAreas.map(i=>{
                return {
                    AreaType: i.AreaType ? i.AreaType : 3,
                    Path: i.Path,
                    ScanBinary: i.ScanBinary,
                    ScanDll: i.ScanDll,
                    ScanMsi: i.ScanMsi,
                    ScanScript: i.ScanScript,
                    __VersionInfo: [1,1]
                }
            }),
        },
        Form_AutoRuleGenerator_Advanced :{
            PrimaryRuleType: sett.PrimaryCondition.RuleType,
            SecondaryRuleType: sett.SecondaryCondition.RuleType,
            UseStrongCertificateCompliance: sett.UseStrongCertificateCompliance,
            AddResultToAppBlockerRules: sett.AddResultToAppBlockerRules,
            RulesAddingStrategyType: sett.RulesAddingStrategyToAppBlocker.RulesAddingStrategyType,
            UseHostInfoInFileName: sett.UseHostInfoInFileName,
            UserOrGroup: sett.UserOrGroup,
            UseExportGeneratedRulesToFile: sett.UseExportGeneratedRulesToFile,
            ExportGeneratedRulesToFile: sett.ExportGeneratedRulesToFile
        },
        Form_AutoRuleGenerator_Excludes : {
            ExcludedAreas: sett.ExcludedAreas,
            UseExcludedAreas: sett.UseExcludedAreas
        }
    };
}

const toViewWzAutoRuleGenRules = (sett) => {
    return {
        RuleNamePrefix: sett.RuleNamePrefix,
        RuleForRunningApplication: sett.RuleForRunningApplication,
        ScanAreas: sett.ScanAreas,
    };
}

const toViewWzAutoRuleGenAdv = (sett) =>{
    return {
        PrimaryRuleType: sett.PrimaryCondition.RuleType,
        SecondaryRuleType: sett.SecondaryCondition.RuleType,
        UseStrongCertificateCompliance: sett.UseStrongCertificateCompliance,
        AddResultToAppBlockerRules: sett.AddResultToAppBlockerRules,
        RulesAddingStrategyType: sett.RulesAddingStrategyToAppBlocker.RulesAddingStrategyType,
        UseHostInfoInFileName: sett.UseHostInfoInFileName,
        UserOrGroup: sett.UserOrGroup,
        UseExportGeneratedRulesToFile: sett.UseExportGeneratedRulesToFile,
        ExportGeneratedRulesToFile: sett.ExportGeneratedRulesToFile
    };
}

const toViewWzAutoRuleGenExcludes = (sett) =>{
    return {
        ExcludedAreas: sett.ExcludedAreas,
        UseExcludedAreas: sett.UseExcludedAreas
    };
}

const toRowAutoRuleGen = (changedData, sett) => {
    sett.RuleNamePrefix = changedData.Form_AutoRuleGenerator_Rules.RuleNamePrefix;
    sett.RuleForRunningApplication = changedData.Form_AutoRuleGenerator_Rules.RuleForRunningApplication;
    sett.ScanAreas = changedData.Form_AutoRuleGenerator_Rules.ScanAreas;

    sett.PrimaryCondition.RuleType = changedData.Form_AutoRuleGenerator_Advanced.PrimaryRuleType;
    sett.SecondaryCondition.RuleType = changedData.Form_AutoRuleGenerator_Advanced.SecondaryRuleType;
    sett.UseStrongCertificateCompliance = changedData.Form_AutoRuleGenerator_Advanced.UseStrongCertificateCompliance;
    sett.AddResultToAppBlockerRules = changedData.Form_AutoRuleGenerator_Advanced.AddResultToAppBlockerRules;
    sett.RulesAddingStrategyToAppBlocker.RulesAddingStrategyType = changedData.Form_AutoRuleGenerator_Advanced.RulesAddingStrategyType;
    sett.UseHostInfoInFileName = changedData.Form_AutoRuleGenerator_Advanced.UseHostInfoInFileName;
    sett.UserOrGroup = changedData.Form_AutoRuleGenerator_Advanced.UserOrGroup;
    sett.UseExportGeneratedRulesToFile = changedData.Form_AutoRuleGenerator_Advanced.UseExportGeneratedRulesToFile;
    sett.ExportGeneratedRulesToFile = changedData.Form_AutoRuleGenerator_Advanced.ExportGeneratedRulesToFile;

    sett.ExcludedAreas = changedData.Form_AutoRuleGenerator_Excludes.ExcludedAreas;
    sett.UseExcludedAreas = changedData.Form_AutoRuleGenerator_Excludes.UseExcludedAreas;
    return sett;
}

const toRowWzAutoRuleGenRules = (changedData, sett) => {
    sett.RuleNamePrefix = changedData.RuleNamePrefix;
    sett.RuleForRunningApplication = changedData.RuleForRunningApplication;
    sett.ScanAreas = changedData.ScanAreas;
    return sett;
}

const toRowWzAutoRuleGenExcluded = (changedData, sett) => {
    sett.ExcludedAreas = changedData.ExcludedAreas;
    sett.UseExcludedAreas = changedData.UseExcludedAreas;
    return sett;
}

const toRowWzAutoRuleGen = (changedData, sett) => {
    sett.PrimaryCondition.RuleType = changedData.PrimaryRuleType;
    sett.SecondaryCondition.RuleType = changedData.SecondaryRuleType;
    sett.UseStrongCertificateCompliance = changedData.UseStrongCertificateCompliance;
    sett.AddResultToAppBlockerRules = changedData.AddResultToAppBlockerRules;
    sett.RulesAddingStrategyToAppBlocker.RulesAddingStrategyType = changedData.RulesAddingStrategyType;
    sett.UseHostInfoInFileName = changedData.UseHostInfoInFileName;
    sett.UserOrGroup = changedData.UserOrGroup;
    sett.UseExportGeneratedRulesToFile = changedData.UseExportGeneratedRulesToFile;
    sett.ExportGeneratedRulesToFile = changedData.ExportGeneratedRulesToFile;
    return sett;
}

module.exports = {
    toViewAutoRuleGen,
    toViewWzAutoRuleGenRules,
    toViewWzAutoRuleGenAdv,
    toViewWzAutoRuleGenExcludes,
    toRowAutoRuleGen,
    toRowWzAutoRuleGenRules,
    toRowWzAutoRuleGenExcluded,
    toRowWzAutoRuleGen
}

