function toViewUpdateSources(sett) {
    return {
        SourceOptions: sett.CommonSettings.SourceOptions,
        ConnectionOptions: sett.CommonSettings.ConnectionOptions
    };
}

function toViewUpdatebasesCommon(sett) {
    return {
        UseDiskIOOptimization: sett.UseDiskIOOptimization,
        MemoryRequeriedForOptimization: sett.MemoryRequeriedForOptimization
    };
}

function toFormsUpdateBases(sett) {
    let data = {
        Form_UpdateBasesSources : toViewUpdateSources(sett),
        Form_UpdateBasesCommon: toViewUpdatebasesCommon(sett)
    }
    return data;
}

function toFormsUpdateComponents(sett) {
    let data = {
        Form_UpdateBasesSources : toViewUpdateSources(sett),
        Form_UpdateComponents_Advanced:{
            Action: sett.Action,
            ServerRebootAllowed: sett.ServerRebootAllowed,
            DownloadPlannedUpdatesInfo: sett.DownloadPlannedUpdatesInfo
        }
    }
    return data;
}

function toFormsRetranslateUpdates(sett) {
    let data = {
        Form_UpdateBasesSources : toViewUpdateSources(sett),
        Form_RetranslateUpdates_Advanced:{
            RetranslationMode: sett.RetranslationMode,
            RetranslationFolder: sett.RetranslationFolder
        }
    }
    return data;
}

function fromFormsUpdateBases(changedData, sett) {
    sett.CommonSettings.SourceOptions = changedData.Form_UpdateBasesSources.SourceOptions;
    sett.CommonSettings.ConnectionOptions = changedData.Form_UpdateBasesSources.ConnectionOptions;
    sett.UseDiskIOOptimization = changedData.Form_UpdateBasesCommon.UseDiskIOOptimization;
    sett.MemoryRequeriedForOptimization = changedData.Form_UpdateBasesCommon.MemoryRequeriedForOptimization;
    return sett;
}

function fromFormsUpdateComponents(changedData, sett) {
    sett.CommonSettings.SourceOptions = changedData.Form_UpdateBasesSources.SourceOptions;
    sett.CommonSettings.ConnectionOptions = changedData.Form_UpdateBasesSources.ConnectionOptions;
    sett.Action = changedData.Form_UpdateComponents_Advanced.Action;
    sett.ServerRebootAllowed = changedData.Form_UpdateComponents_Advanced.ServerRebootAllowed;
    sett.DownloadPlannedUpdatesInfo = changedData.Form_UpdateComponents_Advanced.DownloadPlannedUpdatesInfo;
    return sett;
}

function fromFormsRetranslateUpdates(changedData, sett) {
    sett.CommonSettings.SourceOptions = changedData.Form_UpdateBasesSources.SourceOptions;
    sett.CommonSettings.ConnectionOptions = changedData.Form_UpdateBasesSources.ConnectionOptions;
    sett.RetranslationMode = changedData.Form_RetranslateUpdates_Advanced.RetranslationMode;
    sett.RetranslationFolder = changedData.Form_RetranslateUpdates_Advanced.RetranslationFolder;
    return sett;
}

module.exports = {
    toViewUpdateSources,
    toViewUpdatebasesCommon,
    toFormsUpdateBases,
    toFormsUpdateComponents,
    toFormsRetranslateUpdates,
    fromFormsUpdateBases,
    fromFormsUpdateComponents,
    fromFormsRetranslateUpdates
}