const emptyXmlTag = '\r\n\t\t\t\t\t';

const xmlNs = () => {
    return {xmlns: "urn:kaspersky.com/products/wsee/8.0/export/settings"};
}

const xmlProductInfo = () => {
    return {
        ProductName: [ "Kaspersky Embedded Systems Security"],
        ProductVersion: ["2.1.0.0"]
    };
}

const xmlInfo = (name, category) => {
    return {
        Name: [name],
        Alias: [""],
        Description: [""],
        Category: [category]
    };
}

const xmlSchedule = () => {
    return {
        __VersionInfo: [{ element: ["1", "0"]}],
        Enable: ["no"],
        ActivateTime: ["0"],
        EnableDeactivate: ["no"],
        DeactivateTime: ["0"],
        Frequency: ["0"],
        UnitCount: ["0"],
        DaysOfWeek: ["2"],
        StartTime: ["0"],
        EnableDurationLimit: ["no"],
        DurationLimit: ["60"],
        EnableSuspend: ["no"],
        SuspendFrom: ["0"],
        SuspendTill: ["0"],
        RunMissedTasks: ["no"],
        EnableRandomizationPeriod: [ "no"],
        RandomizationPeriod: ["60"]
    };
}

const xmlRunAs = () => {
    return {
        __VersionInfo: [{element:["1","0"]}],
        Enable: ["no"],
        ImpersonationLogin: [""],
        ImpersonationPassword: [""]
    }
};

const GetTrustedZoneExportXmlJson = (excusions, trustedProceses) => {
    return {
        'KAV-WSEE-Settings': {
            $: xmlNs(),
            ProductInfo: [xmlProductInfo()],
            Settings: [{
                TrustedZone: [{
                    __VersionInfo: [{ element: [ "1", "2" ] }],
                    TrustedProcessesEnabled: ["no"],
                    TrustedProcesses: (trustedProceses  && trustedProceses.length > 0) ? [{ element: trustedProceses }] : [emptyXmlTag],
                    TrustAllBackupReadOperations: ["yes"],
                    ExclutionRules: (excusions  && excusions.length > 0) ? [{ element: excusions }] : [emptyXmlTag],
                    ExclutionRules2: [emptyXmlTag],
                    TrustedProcesses2Enabled: ["no"],
                    TrustedProcesses2: [emptyXmlTag]
                }]
            }]
        }
    };
}

module.exports = {
    xmlNs,
    xmlProductInfo,
    xmlInfo,
    xmlSchedule,
    xmlRunAs,
    GetTrustedZoneExportXmlJson
}