const defaultTrustedZone = () => {
    const tz =  {
        ExclutionRules: { KLPRSS_Val:[[], false], KLPRSS_Mnd:false },
        ExclutionRules2: { KLPRSS_Val:[[], false], KLPRSS_Mnd:false },
        TrustAllBackupReadOperations: { KLPRSS_Val: [ true, false], KLPRSS_Mnd: false },
        TrustedProcesses: { KLPRSS_Val:[[], false], KLPRSS_Mnd:false },
        TrustedProcesses2: { KLPRSS_Val:[[], false], KLPRSS_Mnd:false },
        TrustedProcesses2Enabled: { KLPRSS_Val: [ false, false], KLPRSS_Mnd: false },
        TrustedProcessesEnabled: { KLPRSS_Val: [ false, false], KLPRSS_Mnd: false },
        __VersionInfo:{KLPRSS_Val:[1,2],KLPRSS_Mnd:false}
    };
    return {
        Policy : {
            KLPRSS_Val:tz,
            KLPRSS_Mnd:false
        }
    };
}

const defaultAppControl = () => {
    const appControl =  {
        AdditionalRuleCollection: { KLPRSS_Mnd: false, KLPRSS_Val: [{ type: 'binary',
                value: 'PEFwcGxpY2F0aW9uQ29udHJvbCBWZXJzaW9uPSIxIj48UnVsZUNvbGxlY3Rpb24gLz48L0FwcGxpY2F0aW9uQ29udHJvbD4='
            }, false]
        },
        AllowTrustedApplication: { KLPRSS_Mnd: false, KLPRSS_Val: [false, false]},
        AllowUserOrGroups: {KLPRSS_Mnd: false, KLPRSS_Val: [[], false]},
        BlockInterperetesWhenCliEmpty: {KLPRSS_Mnd: false, KLPRSS_Val: [false, false] },
        BlockUntrustedApplication: { KLPRSS_Mnd: false, KLPRSS_Val: [false, false] },
        EnforsmentMode: {KLPRSS_Mnd: false, KLPRSS_Val: [2, false] },
        MonitorDllLoading: {KLPRSS_Mnd: false, KLPRSS_Val: [true, false] },
        RuleCollection: { KLPRSS_Mnd: false, KLPRSS_Val: [{ type: 'binary',
                value: 'PEFwcGxpY2F0aW9uQ29udHJvbCBWZXJzaW9uPSIxIj48UnVsZUNvbGxlY3Rpb24gLz48L0FwcGxpY2F0aW9uQ29udHJvbD4='
            }, false]
        },
        RuleCollectionProfile: { KLPRSS_Mnd: false,  KLPRSS_Val: [{  type: 'binary',
                value: 'PEFwcGxpY2F0aW9uQ29udHJvbCBWZXJzaW9uPSIxIj48UnVsZUNvbGxlY3Rpb24gLz48L0FwcGxpY2F0aW9uQ29udHJvbD4='
            }, false]
        },
        RuleUsageStrategy: { KLPRSS_Mnd: false, KLPRSS_Val: [1, false] },
        RuleUsageStrategyProfile: { KLPRSS_Mnd: false, KLPRSS_Val: [1, false] },
        TrustBackgroundIntelligentTransferService: { KLPRSS_Mnd: false, KLPRSS_Val: [false, false] },
        TrustWindowsInstaller: { KLPRSS_Mnd: false, KLPRSS_Val: [true, false] },
        TrustedInstallers: { KLPRSS_Mnd: false, KLPRSS_Val: [[], false] },
        UseBinaryRules: { KLPRSS_Mnd: false, KLPRSS_Val: [true, false] },
        UseCache: { KLPRSS_Mnd: false, KLPRSS_Val: [false, false] },
        UseScriptOrMsiRules: { KLPRSS_Mnd: false, KLPRSS_Val: [true, false] },
        UseTrustedInstaller: { KLPRSS_Mnd: false, KLPRSS_Val: [false, false] },
        __VersionInfo: { KLPRSS_Mnd: false, KLPRSS_Val: [1, 8] }
    };
    return {
        Policy : {
            KLPRSS_Val:appControl,
            KLPRSS_Mnd:false
        }
    };
}

module.exports = {
    defaultTrustedZone,
    defaultAppControl,
}