const ScanAreaTypes = {
    None: 0,
    MyComputer: 1,
    Drive: 2,
    Folder: 3,
    File: 4,
    FixedDrives: 5,
    RemovableDrives: 6,
    NetworkDrives: 7,
    StartUp: 8,
    SystemMemory: 9,
    SharedFolders: 10,
    FSObject: 11,	        // special type 'File System Object'
    CheckIntegrity: 12,
    CheckintegrityData: 13,
    ActiveThreats: 14,	    // special type for threats like 'Kido'
    ActiveThreatsQScan: 15
}

const ProtectionLevel = {
    HighSecurity: 1,
    Recommended: 2,
    HighSpeed: 3,
    Custom: 4,
    NonBlocking: 5
}

const ScanTypeEnum = {
    AllObjects: 1,
    ByFormat: 2,
    ByExtension: 3,
    ByMask: 4
}

const CompoundObjectScanModeEnum = {
    All: 1,
    NewAndChanged: 2
}

const ReportingSectionEnum = {
    FileMonitor:1,
    KSN:2,
    ScriptChecker:3,
    HostBlocker:4,
    AntiCryptor:5,
    AntiCryptorNas:6,
    PEP:7,
    RuleGen:8,
    DevControl:9,
    DCRuleGen:10,
    NetApp:11,
    ICAP:12,
    Firewall:13,
    WiFiControl:14,
    Fim:15,
    LogInspector:16,
    AntiExploit:17,
    OnDemand:18,
    Updates:19,
    Quarantine:20,
    Backup:21,
    PlcInvestigate:22,
    PlcCheck:23,
    TrafficSecurity:24,
    checkFim:25,
    Ids:26,
    RegMon:27
}

const TsWcRuleTypeEnum = {
    Url: 1,
    Sert: 2
}

const TmExcludeTypeEnum = {
    Allow: 1,
    Deny: 2
}
const WebActionEnum = {
    BlockDownload: 1,   // Запретить загрузку
    AllowDownload: 2,   // Разрешить загрузку
    Quarantine: 3       // Запретить загрузку и поместить в карантин
}

const NetAppActionEnum = {
    Cure: 1,
    Remove: 2,
    Recommended: 3,
    Report: 4,
    Quarantine: 5,
    Skip: 7
}

const FimModReasonEnum = {
None: 0x00000000,
BasicInfoChanged: 0x00008000,
Closed: 0x80000000,
CompressionChange: 0x00020000,
DataExtended: 0x00000002,
DataOverwrite: 0x00000001,
DataTruncation: 0x00000004,
ExtAttrChange: 0x00000400,
EncriptionChange: 0x00040000,
FileCreate: 0x00000100,
FileDelete: 0x00000200,
HardLinkChange: 0x00010000,
IndexableChange: 0x00004000,
IntegrityChange: 0x00800000,
NamedDataExtend: 0x00000020,
NamedDataOverwrite: 0x00000010,
NamedDataTruncation: 0x00000040,
//ObjectIdChange: 0x00080000,
RenameNewName: 0x00002000,
RenameOldName: 0x00001000,
ReparsePointChange: 0x00100000,
SecurityChange: 0x00000800,
StreamChange: 0x00200000,
TrunsactedChange: 0x00400000
}

const FO_MASKS_GROUP1 = FimModReasonEnum.BasicInfoChanged|FimModReasonEnum.CompressionChange|FimModReasonEnum.RenameNewName;
const FO_MASKS_GROUP2 = FimModReasonEnum.ExtAttrChange|
                        FimModReasonEnum.DataTruncation|
                        FimModReasonEnum.DataExtended|
                        FimModReasonEnum.IndexableChange|
    //                    FimModReasonEnum.ObjectIdChange|
                        FimModReasonEnum.HardLinkChange|
                        FimModReasonEnum.ReparsePointChange|
                        FimModReasonEnum.DataOverwrite;
const FO_MASKS_GROUP3 = FimModReasonEnum.FileCreate|FimModReasonEnum.FileDelete;
const FO_MASKS_GROUP4 = FimModReasonEnum.SecurityChange|FimModReasonEnum.EncriptionChange;
const FO_MASKS_GROUP5 = FimModReasonEnum.IntegrityChange|
                        FimModReasonEnum.NamedDataExtend|
                        FimModReasonEnum.NamedDataOverwrite|
                        FimModReasonEnum.NamedDataTruncation|
                        FimModReasonEnum.StreamChange|
                        FimModReasonEnum.TrunsactedChange;

const AllFimOperators = FO_MASKS_GROUP1|FO_MASKS_GROUP2|FO_MASKS_GROUP3|FO_MASKS_GROUP4|FO_MASKS_GROUP5;

const NwcLicType = {
    onPrem: 0,
    BusinessSelect: 1,
    BusinessAdvanced : 2,
    EnterpriseServer: 3,
}

module.exports = {
    ScanAreaTypes,
    ProtectionLevel,
    ScanTypeEnum,
    CompoundObjectScanModeEnum,
    ReportingSectionEnum,
    TsWcRuleTypeEnum,
    TmExcludeTypeEnum,
    WebActionEnum,
    NetAppActionEnum,
    FimModReasonEnum,
    FO_MASKS_GROUP1,
    FO_MASKS_GROUP2,
    FO_MASKS_GROUP3,
    FO_MASKS_GROUP4,
    FO_MASKS_GROUP5,
    AllFimOperators,
    NwcLicType
}